﻿using System;
using System.IO;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace DateTamperer
{
    public partial class MainForm : Form
    {
        public MainForm()
        {
            InitializeComponent();
        }

        private void aboutToolStripMenuItem_Click(object sender, EventArgs e)
        {
            AboutBox ab = new AboutBox();
            ab.Show();
        }

        private void btnSelectFile_Click(object sender, EventArgs e)
        {
            ofd.ShowDialog();
            this.tbFile.Text = ofd.FileName;
            string filename = ofd.FileName;
            if (File.Exists(filename))
            {
                FileInfo fi = new FileInfo(filename);
                this.tbCurrentAccessed.Text = fi.LastAccessTime.ToString();
                this.tbCurrentCreated.Text = fi.CreationTime.ToString();
                this.tbCurrentModified.Text = fi.LastWriteTime.ToString();
            }
            else
            {
                MessageBox.Show("Error!!!!");
            }

        }

        private void btnSelectFolder_Click(object sender, EventArgs e)
        {

            fbd.ShowDialog();
            this.tbFolder.Text = fbd.SelectedPath;
        }

        private void cbEvery_CheckedChanged(object sender, EventArgs e)
        {
            this.tbExt.Text = "*.*";
        }

        private void btnSingleDoit_Click(object sender, EventArgs e)
        {
            string singlefile = this.tbFile.Text;
            if (singlefile == "")
            {
                MessageBox.Show("Fail. Try setting text first.");
                return;
            }
            if (File.Exists(singlefile))
            {
                DateTamper(singlefile,0);
            }
            else
            {
                MessageBox.Show("No file name readable. Try again.");
                return;
            }
            
        }
        

        private void btnMultiDoit_Click(object sender, EventArgs e)
        {
            string foldername = this.tbFolder.Text;
            string extension =  this.tbExt.Text;
            if (foldername == "")
            {
                MessageBox.Show("Fail, foldername cannot be blank");
                return;
            }

            if (cbAllDirs.Checked)
            {
                foreach (string filenamez in Directory.EnumerateFiles(foldername, extension, SearchOption.AllDirectories))
                {
                    DateTamper(filenamez, 1);
                }
            }
            else
            {
                foreach (string filenamez in Directory.EnumerateFiles(foldername, extension, SearchOption.TopDirectoryOnly))
                {
                    DateTamper(filenamez, 1);
                }
            }
            
            
            
        }

        private bool DateTamper(string filename, int type)
        {
            FileInfo fi = new FileInfo(filename);
            if (type == 0) //  single file mode
            {
                DateTime newaccess, newcreated, newmodified;
                newaccess   =   dtpNewAccessed.Value;
                newcreated  =   dtpNewCreated.Value;
                newmodified =   dtpNewModified.Value;
                fi.CreationTime = newcreated;
                fi.LastAccessTime = newaccess;
                fi.LastWriteTime = newmodified;
                this.tbResults.Text += "File " + filename + " successfully changed. See you in court!\r\n";
                return true;
            }
            if (type == 1) // Multi file mode
            {
                DateTime newaccess, newcreated, newmodified;
                newaccess = dtpNewAccessed.Value;
                newcreated = dtpNewCreated.Value;
                newmodified = dtpNewModified.Value;
                fi.CreationTime = newcreated;
                fi.LastAccessTime = newaccess;
                fi.LastWriteTime = newmodified;

                this.tbResults.Text += "File " + filename + " successfully changed. See you in court!\r\n";
               
            }
            return false;
        }

       
    }
}
